 {===========================================================================================}
{	LlamaTalk Echo Server}
{	}
{	Copyright  1994 Apple Computer, Inc.}
{	All rights reserved.}
{	}
{	Modification Status}
{	YY/MM/DD	Name				Comments}
{	94/07/07	Jim Schram		Released as 1.0a3}
{	94/03/17	Jim Schram		Initial Development}
{-------------------------------------------------------------------------------------------------------------}

Program LlamaTalkEchoApp;

	Uses
		Processes, LlamaTalk;

	Var
		gErr: OSErr;
		gSocket: Short;
		gSocketStatus: LTSocketStatusRec;
		gSocketConfigHdl: Handle;
		gSocketAddressHdl: Handle;
		gLlamaTalkGlobals: LTGlobalsHdl;
		gToolName: Str255;
		gInDataHdl: Handle;
		gOutDataHdl: Handle;
		gEvent: EventRecord;
		gQuit: Boolean;

{-------------------------------------------------------------------------------------------------------------}

	Function N2S (theNumber: Long): Str255;
		Var
			theString: Str255;
	Begin
		NumToString(theNumber, theString);
		N2S := theString;
	End;

{-------------------------------------------------------------------------------------------------------------}

	Function TextToHex (text: Handle): Handle;
		Const
			kHexTable = '0123456789ABCDEF';
		Var
			h: CharsHandle;
			x: Long;
			i: Long;
	Begin
		h := Nil;
		If text <> Nil Then Begin
				h := CharsHandle(NewHandle(GetHandleSize(text) * 4 + 5));
				h^^[0] := 'H';
				h^^[1] := 'e';
				h^^[2] := 'x';
				h^^[3] := ':';
				x := 4;
				For i := 0 To GetHandleSize(text) - 1 Do Begin
						h^^[x] := ' ';
						x := x + 1;
						h^^[x] := ' ';
						x := x + 1;
						h^^[x] := kHexTable[Ord(CharsHandle(text)^^[i]) Div 16 + 1];
						x := x + 1;
						h^^[x] := kHexTable[Ord(CharsHandle(text)^^[i]) Mod 16 + 1];
						x := x + 1;
					End;
				h^^[x] := Chr(0);
			End;
		TextToHex := Handle(h);
	End;

{===========================================================================================}

Begin
	ShowText;
	InitCursor;

	writeln('Welcome to LlamaTalk!');
	writeln('Written by Jim Schram, PIE DTS.');
	writeln('Copyright  1994 Apple Computer, Inc.  All rights reserved.');
	writeln;
	writeln('This is an echo server for the LlamaTalk sample code (for debugging).');
	writeln('It receives data, converts each byte to a hex string, and sends it back.');
	writeln;
	writeln('Yea, this interface sucks, but I don''t care!  (It''s sample code!)');
	writeln('');
	writeln('Press Command-Period to Quit.');
	writeln;

	gLlamaTalkGlobals := Nil;
	gSocket := 0;
	gQuit := FALSE;
	gToolName := '';

	gErr := LTOpenLlamaTalk(1, gLlamaTalkGlobals);
	If gErr <> noErr Then
		writeln(concat('Error ', N2S(gErr), ' occured opening LlamaTalk!'))
	Else
		Repeat
			LTIdle(gLlamaTalkGlobals);

			If LTIsValidSocket(gLlamaTalkGlobals, gSocket) Then Begin
					gInDataHdl := LTRead(gLlamaTalkGlobals, gSocket);
					If gInDataHdl <> Nil Then Begin
							writeln('Echo!');
							gOutDataHdl := TextToHex(gInDataHdl);
							LTWrite(gLlamaTalkGlobals, gSocket, gOutDataHdl);
							DisposHandle(gInDataHdl);
						End
					Else
						Case LTGetSocketState(gLlamaTalkGlobals, gSocket) Of
							cLTStateError:  Begin
									writeln('Socket is in error state, disposing of socket...');
									LTDisposeSocket(gLlamaTalkGlobals, gSocket);
									gSocket := 0;
								End;
						End
				End

			Else Begin
					gToolName := 'AppleTalk ADSP Tool';
					gSocketAddressHdl := GetNamedResource('LAMA', 'ADSP Address');
					gSocketConfigHdl := GetNamedResource('LAMA', 'ADSP Configuration');
					If gSocketConfigHdl = Nil Then Begin

							gToolName := 'Apple Modem Tool';
							gSocketAddressHdl := GetNamedResource('LAMA', 'MNP Address');
							gSocketConfigHdl := GetNamedResource('LAMA', 'MNP Configuration');
							If gSocketConfigHdl = Nil Then

								If LTChoose(gToolName, gSocketConfigHdl) Then
									;
						End;

					If gSocketConfigHdl <> Nil Then Begin
							gErr := LTNewSocket(gLlamaTalkGlobals, gToolName, gSocketConfigHdl, gSocketAddressHdl, 10, 10, gSocket);
							If gErr = noErr Then Begin
									writeln;
									writeln('Waiting for connection...');
									LTListen(gLlamaTalkGlobals, gSocket);
								End
							Else
								writeln(concat('Error ', N2S(gErr), ' occured creating the new LlamaTalk socket!'));
						End;
				End;

			If GetNextEvent(everyEvent, gEvent) Then
				If gEvent.what = keyDown Then
					If BAND(gEvent.modifiers, $1000 + $0800 + $0200 + $0100) = $0100 Then		{command}
						If BAND(gEvent.message, $000000FF) = $2E Then											{period}
							gQuit := TRUE;

		Until gQuit;
	writeln('Bye Bye!');

	LTCloseLlamaTalk(gLlamaTalkGlobals);

{===========================================================================================}

End.